Description

External node script provided by foreman could use puppet's log facility so that all messages could be seen in one log.

Here is an example:

#! /usr/bin/ruby

1. a simple script which fetches external nodes from Foreman

2. you can basically use anything that knows how to get http data, e.g. wget/curl etc.

1. Foreman url

foreman_url="http://foreman:3000"

require 'net/http'

require 'puppet'

Puppet.parse_config

Puppet::Util::Log.level = :debug

Puppet::Util::Log.newdestination(:syslog)

foreman_url += "/node/#{ARGV

0

}?format=yml"

url = URI.parse(foreman_url)

req = Net::HTTP::Get.new(foreman_url)

res = Net::HTTP.start(url.host, url.port) { |http|

http.request(req)

}

case res

when Net::HTTPOK

puts res.body

Puppet.debug("Foreman response for node %s is ok" % ARGV

0

)

else

msg = "Error retrieving node %s: %s" % [ARGV

0

, res.class]

$stderr.puts msg

Puppet.err(msg)

end

History

#1 - 10/20/2010 03:03 PM - Ohad Levy

Did you compare how much longer it takes to run the script? loading the puppet lib is usually an expensive operation.

can you try to do some stress tests? e.g. run 20 external nodes lookup per second? or alternatively, load the puppet libs only if there is a failure to

report?

Thanks!
#2 - 11/09/2010 08:10 AM - Ohad Levy

- Status changed from New to Feedback

- Assignee set to Gustavo Soares

#3 - 06/19/2011 03:42 AM - Ohad Levy

- Project changed from Foreman to Installer

#4 - 09/20/2013 12:57 PM - Dominic Cleal

- Description updated

- Status changed from Feedback to Rejected

Loading puppet into things like Foreman core has caused us many problems (#2414), so we don't want to include this in the ENC script.
